#!/usr/bin/env python
# Copyright 2014 Teemu Piippo
# Redistributable under terms of 3-clause BSD
#
# get_dateversion.py [<changeset>]
#
# Finds out the version number and date version of the
# Zandronum source base this script is executed in. Must be run in a valid
# Mercurial repository.

from datetime import datetime
import sys
import subprocess
import re

regexps = [ \
	re.compile (r'#define\s+GAMEVER_STRING\s+"([^"]+)"'), \
	re.compile (r'#define\s+DOTVERSIONSTR_NOREV\s+"([^"]+)"'), \
	re.compile (r'#define\s+DOTVERSIONSTR\s+"([^"]+)"'), \
]

rev='.'

if len (sys.argv) >= 2:
	rev = sys.argv[1]

timestring = subprocess.check_output (['hg', 'log', '-r', rev, '--template', '{date|hgdate}']) \
	.replace ('\n', '').split (' ')[0]

version_h = subprocess.check_output (['hg', 'cat', '-r', rev, 'src/version.h']).split('\n')

zanversion='unknown'
for line in version_h:
	for rex in regexps:
		match = rex.match (line)
		if match != None:
			zanversion = match.group (1)
			break
	else:
		continue
	break

print "%s %s" % (zanversion, datetime.utcfromtimestamp (int (timestring)).strftime ('%y%m%d-%H%M'))
